#!/usr/bin/perl

#*****************************************************************************
#
# wanpipe_cfg.cgi WANPIPE WEB Configuration sample CGI script.
#
#		This module is can be used to configure Sangoma WAPIPE from
#		a WEB browser.
#
# Authors:	Nenad Corbic
#		David Rokhvarg
#
# Description:
#
#	1. Copy the two CGI, perl files into your
#   	   web-server cgi-bin directory.
#
#	2. Make sure wanpipe_cfg.cg has executable
#   	   permission.
#
#
#	3. The web server must have ROOT/ADMIN
#   	   privileges in order to load wanpipe modules.
#   
#   	   Wanpipe modules must be loaded to determine
#   	   the hardware information.
#
#   	   OR
#
#   	   wanpipe modules must be loaded manually via:
#   
#   	   wanrouter hwprobe
#
#   	   Before attempting to run wanpipe webcfg.
#   
#	4. The web browser must also be able to write to
#   	   /etc/wanpipe and /etc/wanpipe/interfaces
#   	   directories.
#
#	5. From your web browser call the wanpipe_cfg.cgi.
#
#          http:/localhost/cgi-bin/wanpipe_cfg.cgi
#
#
# Copyright:	(c) 1995-2004 Sangoma Technologies Inc.
#
#		This program is free software; you can redistribute it and/or
#		modify it under the terms of the GNU General Public License
#		as published by the Free Software Foundation; either version
#		2 of the License, or (at your option) any later version.
# ============================================================================
# Feb 18, 2004	v. 1.1	Nenad Corbic	Added AFT card support 
# Jan 9, 2003	v. 1.0			Initial version.
#

require "wanpipe_class.pl";

package MAIN;

#=====================================
#Include files
#=====================================
use strict;
use CGI;

my $cgi = CGI->new;

$|=1;

#Print the HTML Header
print $cgi->header(); 

#Check if we have any form parametrs. 
#If not, then display our main screen.
if (!($cgi->param())) {
	#Display the main page
	my $page = new MAIN_PAGE;
	$page->display();
	exit 0;
}

my @PARAMS=$cgi->param();

#for debugging it will print key/value pairs
foreach(@PARAMS){
	#printf "$_ = %s<br>", $cgi->param($_);
}

#
#This substitutes 'param("page")' with the
#name of the class (package) to be instantiated.
#
#It means all buttons on the main page 
#of type 'submit' should be named "page" (name=\"page\").
#
#For example: if 'param("page")' returns
#'Advanced_Frame_Relay_Configuration', 
#then an instance of 'Advanced_Frame_Relay_Configuration'
#class will be created.
#
my $page = $cgi->param("page")->new;
if (!$page){
	my $class_name = $cgi->param("page");
	print "<br> Failed to create an instance of $class_name !<br>";
}

#remove blank spaces
for my $val (@PARAMS){
	$val =~ s/ //g;
	$page->$val($cgi->param("$val"));
}

#if display() function is not implemented
#in a class, report it
if ($page->display()){
	print "<br>Page not supported!<br>\n";
}

print $cgi->end_html();

exit 0

#---- END OF MAIN----- #
