#!/usr/bin/perl

#*****************************************************************************
#
# wanpipe_class.pl WANPIPE WEB Configuration sample CGI script.
#
#		Classes used by WANPIPE WEB Configuration script.
#
# Authors:	Nenad Corbic
#		David Rokhvarg
#
# Copyright:	(c) 1995-2003 Sangoma Technologies Inc.
#
#		This program is free software; you can redistribute it and/or
#		modify it under the terms of the GNU General Public License
#		as published by the Free Software Foundation; either version
#		2 of the License, or (at your option) any later version.
# ============================================================================
# January 9, 2003	v. 1.00		Initial version.
#

use strict;

my $default_wanpipe_conf_file = "/etc/wanpipe/wanpipe1.conf";

my $default_chdlc_interface = "/etc/wanpipe/interfaces/wp1chdlc";
my $default_fr_interface    = "/etc/wanpipe/interfaces/wp1fr";
my $default_ppp_interface   = "/etc/wanpipe/interfaces/wp1ppp";
my $default_adsl_interface  = "/etc/wanpipe/interfaces/wp1adsl";
my $default_aft_interface  = "/etc/wanpipe/interfaces/wp1aft";
my $ip_conf_file = "?";

my @ip_conf_file_data;
my @conf_file_data;

my $protocol_none = 0;
my $protocol_fr   = 1;
my $protocol_chdlc= 2;
my $protocol_ppp  = 3;
my $protocol_adsl = 4;
my $protocol_aft  = 5;

my $wan_protocol=$protocol_none;

my $card_arch_s514=0;
my $card_arch_aft=1;

my $card_type;
my $card_arch;
my $card_type_t1="t1";
my $card_type_e1="e1";
my $card_type_serial="serial";
my $card_type_adsl="adsl";
my $card_type_unknown="unknown";

my $active_channels="?";

my $local_ip_addr=" ";
my $remote_ip_addr=" ";
my $netmask="255.255.255.0";
my $gateway_ip_addr=" ";

my $fr_radio_button_state = " ";
my $fr_ansi_radio_button_state  = " ";
my $fr_lmi_radio_button_state = " ";
my $fr_Q933_radio_button_state = " ";
my $ppp_radio_button_state = " ";
my $chdlc_radio_button_state = " "; 

my $T1_radio_button_state = " ";
my $E1_radio_button_state = " ";

my $V35_radio_button_state = " ";
my $RS232_radio_button_state = " ";

my $ETH_LLC_OA_state = " ";
my $ETH_VC_OA_state = " ";
my $IP_LLC_OA_state = " ";
my $IP_VC_OA_state = " ";
my $PPP_LLC_OA_state = " ";
my $PPP_VC_OA_state = " ";

my $atm_vpi_vci_autocfg="checked";
my $atm_vpi="AUTO";
my $atm_vci="AUTO";

my $chap_secrets_file="/etc/ppp/chap-secrets";
my $pap_secrets_file="/etc/ppp/pap-secrets";

my $sign_on_ppp="?";
my $password_ppp="?";

my @chap_file_data;
my @pap_file_data;

my $prot_hash;

$prot_hash->{"WAN_FR"} ="MP_FR";
$prot_hash->{"WAN_PPP"}="MP_PPP";
$prot_hash->{"WAN_CHDLC"}="MP_CHDLC";
$prot_hash->{"MP_FR"} ="WAN_FR";
$prot_hash->{"MP_PPP"}="WAN_PPP";
$prot_hash->{"MP_CHDLC"}="WAN_CHDLC";


#
#ADSL
#

my @adsl_defaul_ip_cfg = 
(
"#\n",
"#Default configuration for ADSL interface\n",
"#name : wp1adsl\n",
"#\n", 
"DEVICE=wp1adsl\n",
"IPADDR=\n",
"NETMASK=255.255.255.255\n",
"POINTOPOINT=\n",
"ONBOOT=yes\n",
"GATEWAY=\n"
);

my @adsl_default_hardware_cfg = 
(
"#================================================\n",
"# WANPIPE1 Configuration File\n",
"#================================================\n",
"#\n",
"# Note: This file was generated automatically\n",
"#       by /usr/local/wanrouter/wancfg program.\n",
"#\n",
"#       If you want to edit this file, it is\n",
"#       recommended that you use wancfg program\n",
"#       to do so.\n",
"#================================================\n",
"# Sangoma Technologies Inc.\n",
"#================================================\n",
"\n",
"[devices]\n",
"wanpipe1 = WAN_ADSL, Comment\n",
"\n",
"[interfaces]\n",
"wp1adsl = wanpipe1, , PPPoE, Comment\n",
"\n",
"[wanpipe1]\n",
"CARD_TYPE 	= S518\n",
"AUTO_PCISLOT	= YES\n",
"PCISLOT 	= 0\n",
"PCIBUS		= 0\n",
"MTU 		= 1500\n",
"UDPPORT 	= 9000\n",
"\n", 
"EncapMode	= ETH_LLC_OA\n",
"ATM_AUTOCFG	= YES\n",
"Vci		= 35\n",
"Vpi		= 0\n",
"\n", 
"Verbose		= 1\n",
"RxBufferCount		= 50\n",
"TxBufferCount		= 50\n",
"AdslStandard		= ADSL_MULTIMODE\n",
"AdslTrellis		= ADSL_TRELLIS_ENABLE\n",
"AdslTxPowerAtten	= 0\n",
"AdslCodingGain		= ADSL_AUTO_CODING_GAIN\n",
"AdslMaxBitsPerBin	= 0x0E\n",
"AdslTxStartBin		= 0x06\n",
"AdslTxEndBin		= 0x1F\n",
"AdslRxStartBin		= 0x06\n",
"AdslRxEndBin		= 0xFF\n",
"AdslRxBinAdjust	= ADSL_RX_BIN_DISABLE\n",
"AdslFramingStruct	= ADSL_FRAMING_TYPE_3\n",
"AdslExpandedExchange	= ADSL_EXPANDED_EXCHANGE\n",
"AdslClockType		= ADSL_CLOCK_CRYSTAL\n",
"AdslMaxDownRate	= 8192\n",
"\n", 
"TTL 		= 255\n",
"IGNORE_FRONT_END  = NO\n",
"\n",
"[wp1adsl]\n"
);

my @aft_default_hardware_cfg_t1 = 
(
"#================================================\n",
"# WANPIPE1 Configuration File				\n",
"#================================================	\n",
"#\n",
"# Note: This file was generated automatically\n",
"#       by /usr/sbin/wancfg program.\n",
"#\n",
"#       If you want to edit this file, it is\n",
"#       recommended that you use wancfg program\n",
"#       to do so.\n",
"#================================================\n",
"# Sangoma Technologies Inc.\n",
"#================================================\n",
"\n",
"[devices]\n",
"wanpipe1 = WAN_AFT, Comment\n",
"\n",
"[interfaces]\n",
"wp1aft = wanpipe1, , WANPIPE, Comment\n",
"\n",
"[wanpipe1]\n",
"CARD_TYPE 	= AFT\n",
"S514CPU 	= A\n",
"AUTO_PCISLOT	= YES\n",
"PCISLOT 	= 1\n",
"PCIBUS		= 2\n",
"MEDIA 		= T1\n",
"LCODE 		= B8ZS\n",
"FRAME 		= ESF\n",
"TE_CLOCK 	= NORMAL\n",
"ACTIVE_CH	= ALL\n",
"LBO 		= 0DB\n",
"Firmware	= /etc/wanpipe/firmware/cdual514.sfm\n",
"Interface 	= V35\n",
"Clocking 	= External\n",
"BaudRate 	= 1540000\n",
"MTU 		= 1500\n",
"UDPPORT 	= 9000\n",
"TTL 		= 255\n",
"IGNORE_FRONT_END  = NO\n",
"\n",
"[wp1aft]\n",
"ACTIVE_CH	= ALL\n",
"PROTOCOL	= MP_FR\n",
"IGNORE_DCD	= NO\n",
"IGNORE_CTS	= NO\n",
"HDLC_STREAMING	= YES\n",
"DYN_INTR_CFG	= NO\n"
);

my @aft_default_hardware_cfg_e1 = 
(
"#================================================\n",
"# WANPIPE1 Configuration File				\n",
"#================================================	\n",
"#\n",
"# Note: This file was generated automatically\n",
"#       by /usr/sbin/wancfg program.\n",
"#\n",
"#       If you want to edit this file, it is\n",
"#       recommended that you use wancfg program\n",
"#       to do so.\n",
"#================================================\n",
"# Sangoma Technologies Inc.\n",
"#================================================\n",
"\n",
"[devices]\n",
"wanpipe1 = WAN_AFT, Comment\n",
"\n",
"[interfaces]\n",
"wp1aft = wanpipe1, , WANPIPE, Comment\n",
"\n",
"[wanpipe1]\n",
"CARD_TYPE 	= AFT\n",
"S514CPU 	= A\n",
"AUTO_PCISLOT	= YES\n",
"PCISLOT 	= 1\n",
"PCIBUS		= 2\n",
"MEDIA          = E1\n",
"LCODE          = HDB3\n",
"FRAME          = NCRC4\n",
"TE_CLOCK       = NORMAL\n",
"ACTIVE_CH      = ALL\n",
"Firmware	= /etc/wanpipe/firmware/cdual514.sfm\n",
"Interface 	= V35\n",
"Clocking 	= External\n",
"BaudRate 	= 1540000\n",
"MTU 		= 1500\n",
"UDPPORT 	= 9000\n",
"TTL 		= 255\n",
"IGNORE_FRONT_END  = NO\n",
"\n",
"[wp1aft]\n",
"ACTIVE_CH	= ALL\n",
"PROTOCOL	= MP_FR\n",
"IGNORE_DCD	= NO\n",
"IGNORE_CTS	= NO\n",
"HDLC_STREAMING	= YES\n",
"DYN_INTR_CFG	= NO\n"
);


my @aft_defaul_ip_cfg =
(
"# Default configuration for AFT interface\n",
"# name:	wp1aft\n",
"#\n",
"DEVICE=wp1aft\n",
"IPADDR=\n",
"NETMASK=255.255.255.255\n",
"POINTOPOINT=\n",
"ONBOOT=yes\n",
"GATEWAY=\n"
);



#
#Frame Relay
#
my @fr_defaul_ip_cfg =
(
"# Default configuration for Frame Relay interface\n",
"# name:	wp1fr\n",
"#\n",
"DEVICE=wp1fr\n",
"IPADDR=\n",
"NETMASK=255.255.255.255\n",
"POINTOPOINT=\n",
"ONBOOT=yes\n",
"GATEWAY=\n"
);

my @fr_default_hardware_cfg_serial = 
(
"#================================================\n",
"# WANPIPE1 Configuration File\n",
"#================================================\n",
"#\n",
"# Note: This file was generated automatically\n",
"#       by /usr/local/wanrouter/wancfg program.\n",
"#\n",
"#       If you want to edit this file, it is\n",
"#       recommended that you use wancfg program\n",
"#       to do so.\n",
"#================================================\n",
"# Sangoma Technologies Inc.\n",
"#================================================\n",
"\n",
"[devices]\n",
"wanpipe1 = WAN_FR, Comment\n",
"\n",
"[interfaces]\n",
"wp1fr = wanpipe1, auto, WANPIPE, Comment\n",
"\n",
"[wanpipe1]\n",
"CARD_TYPE 	= S51X\n",
"S514CPU 	= A\n",
"AUTO_PCISLOT	= YES\n",
"PCISLOT 	= 0\n",
"PCIBUS		= 0\n",
"Firmware	= /etc/wanpipe/firmware/fr514.sfm\n",
"Interface 	= V35\n",
"Clocking 	= External\n",
"BaudRate 	= 1540000\n",
"MTU 		= 1500\n",
"UDPPORT 	= 9000\n",
"NUMBER_OF_DLCI	= 1\n",
"Station 	= CPE\n",
"Signalling 	= ANSI\n",
"T391 		= 10\n",
"T392 		= 16\n",
"N391 		= 6\n",
"N392 		= 3\n",
"N393 		= 4\n",
"FR_ISSUE_FS	= YES\n",
"TTL 		= 255\n",
"IGNORE_FRONT_END  = NO\n",
"\n",
"[wp1fr]\n",
"MULTICAST 	= NO\n",
"INARP 		= NO\n",
"INARPINTERVAL 	= 0\n",
"INARP_RX	= NO\n",
"IPX		= NO\n",
"TRUE_ENCODING_TYPE = NO\n",
"DYN_INTR_CFG	= NO\n"
);

my @fr_default_hardware_cfg_t1 = 
(
"#================================================\n",
"# WANPIPE1 Configuration File\n",
"#================================================\n",
"#\n",
"# Note: This file was generated automatically\n",
"#       by /usr/local/wanrouter/wancfg program.\n",
"#\n",
"#       If you want to edit this file, it is\n",
"#       recommended that you use wancfg program\n",
"#       to do so.\n",
"#================================================\n",
"# Sangoma Technologies Inc.\n",
"#================================================\n",
"\n",
"[devices]\n",
"wanpipe1 = WAN_FR, Comment\n",
"\n",
"[interfaces]\n",
"wp1fr = wanpipe1, auto, WANPIPE, Comment\n",
"\n",
"[wanpipe1]\n",
"CARD_TYPE 	= S51X\n",
"S514CPU 	= A\n",
"AUTO_PCISLOT	= YES\n",
"PCISLOT 	= 3\n",
"PCIBUS		= 1\n",
"MEDIA 		= T1\n",
"LCODE 		= B8ZS\n",
"FRAME 		= ESF\n",
"TE_CLOCK 	= NORMAL,\n",
"ACTIVE_CH	= ALL\n",
"LBO 		= 0DB\n",
"Firmware	= /etc/wanpipe/firmware/fr514.sfm\n",
"Interface 	= V35\n",
"Clocking 	= External\n",
"BaudRate 	= 1540000\n",
"MTU 		= 1500\n",
"UDPPORT 	= 9000\n",
"NUMBER_OF_DLCI = 1\n",
"Station 	= CPE\n",
"Signalling 	= ANSI\n",
"T391 		= 10\n",
"T392 		= 16\n",
"N391 		= 6\n",
"N392 		= 3\n",
"N393 		= 4\n",
"FR_ISSUE_FS	= YES\n",
"TTL 		= 255\n",
"IGNORE_FRONT_END  = NO\n",
"\n",
"[wp1fr]\n",
"MULTICAST 	= NO\n",
"INARP 		= NO\n",
"INARPINTERVAL 	= 0\n",
"INARP_RX	= NO\n",
"IPX		= NO\n",
"TRUE_ENCODING_TYPE	= NO\n",
"DYN_INTR_CFG	= NO\n"
);

my @fr_default_hardware_cfg_e1 = 
(
"#================================================\n",
"# WANPIPE1 Configuration File\n",
"#================================================\n",
"#\n",
"# Note: This file was generated automatically\n",
"#       by /usr/local/wanrouter/wancfg program.\n",
"#\n",
"#       If you want to edit this file, it is\n",
"#       recommended that you use wancfg program\n",
"#       to do so.\n",
"#================================================\n",
"# Sangoma Technologies Inc.\n",
"#================================================\n",
"\n",
"[devices]\n",
"wanpipe1 = WAN_FR, Comment\n",
"\n",
"[interfaces]\n",
"wp1fr = wanpipe1, auto, WANPIPE, Comment\n",
"\n",
"[wanpipe1]\n",
"CARD_TYPE 	= S51X\n",
"S514CPU 	= A\n",
"AUTO_PCISLOT	= YES\n",
"PCISLOT 	= 3\n",
"PCIBUS		= 1\n",
"MEDIA 		= E1\n",
"LCODE 		= HDB3\n",
"FRAME 		= NCRC4\n",
"TE_CLOCK 	= NORMAL\n",
"ACTIVE_CH	= ALL\n",
"LBO 		= 0DB\n",
"Firmware	= /etc/wanpipe/firmware/fr514.sfm\n",
"Interface 	= V35\n",
"Clocking 	= External\n",
"BaudRate 	= 1540000\n",
"MTU 		= 1500\n",
"UDPPORT 	= 9000\n",
"NUMBER_OF_DLCI = 1\n",
"Station 	= CPE\n",
"Signalling 	= ANSI\n",
"T391 		= 10\n",
"T392 		= 16\n",
"N391 		= 6\n",
"N392 		= 3\n",
"N393 		= 4\n",
"FR_ISSUE_FS	= YES\n",
"TTL 		= 255\n",
"IGNORE_FRONT_END  = NO\n",
"\n",
"[wp1fr]\n",
"MULTICAST 	= NO\n",
"INARP 		= NO\n",
"INARPINTERVAL 	= 0\n",
"INARP_RX	= NO\n",
"IPX		= NO\n",
"TRUE_ENCODING_TYPE	= NO\n",
"DYN_INTR_CFG	= NO\n"
);
#
#PPP
#
my @ppp_defaul_ip_cfg =
(
"# Wanrouter interface configuration file\n",
"# name:	wp1ppp\n",
"#\n",
"DEVICE=wp1ppp\n",
"IPADDR=\n",
"NETMASK=255.255.255.255\n",
"POINTOPOINT=\n",
"ONBOOT=yes\n",
"GATEWAY=\n"
);

my @ppp_default_hardware_cfg_serial = 
(
"#================================================\n",
"# WANPIPE1 Configuration File\n",
"#================================================\n",
"#\n",
"# Note: This file was generated automatically\n",
"#       by /usr/local/wanrouter/wancfg program.\n",
"#\n",
"#       If you want to edit this file, it is\n",
"#       recommended that you use wancfg program\n",
"#       to do so.\n",
"#================================================\n",
"# Sangoma Technologies Inc.\n",
"#================================================\n",
"\n",
"[devices]\n",
"wanpipe1 = WAN_PPP, Comment\n",
"\n",
"[interfaces]\n",
"wp1ppp = wanpipe1, , WANPIPE, Comment\n",
"\n",
"[wanpipe1]\n",
"CARD_TYPE 	= S51X\n",
"S514CPU 	= A\n",
"AUTO_PCISLOT	= YES\n",
"PCISLOT 	= 6\n",
"PCIBUS		= 0\n",
"Firmware	= /etc/wanpipe/firmware/ppp514.sfm\n",
"Interface 	= V35\n",
"Clocking 	= External\n",
"BaudRate 	= 1540000\n",
"MTU 		= 1500\n",
"UDPPORT 	= 9000\n",
"IP_MODE	= STATIC\n",
"TTL 		= 255\n",
"IGNORE_FRONT_END  = NO\n",
"\n",
"[wp1ppp]\n",
"MULTICAST 	= NO\n",
"PAP       	= NO\n",
"CHAP		= NO\n",
"IPX		= NO\n",
"DYN_INTR_CFG	= NO\n"
);

my @ppp_default_hardware_cfg_t1 = 
(
"#================================================\n",
"# WANPIPE1 Configuration File\n",
"#================================================\n",
"#\n",
"# Note: This file was generated automatically\n",
"#       by /usr/local/wanrouter/wancfg program.\n",
"#\n",
"#       If you want to edit this file, it is\n",
"#       recommended that you use wancfg program\n",
"#       to do so.\n",
"#================================================\n",
"# Sangoma Technologies Inc.\n",
"#================================================\n",
"\n",
"[devices]\n",
"wanpipe1 = WAN_PPP, Comment\n",
"\n",
"[interfaces]\n",
"wp1ppp = wanpipe1, , WANPIPE, Comment\n",
"\n",
"[wanpipe1]\n",
"CARD_TYPE 	= S51X\n",
"S514CPU 	= A\n",
"AUTO_PCISLOT	= YES\n",
"PCISLOT 	= 3\n",
"PCIBUS		= 1\n",
"MEDIA 		= T1\n",
"LCODE 		= B8ZS\n",
"FRAME 		= ESF\n",
"TE_CLOCK 	= NORMAL\n",
"ACTIVE_CH	= ALL\n",
"LBO 		= 0DB\n",
"Firmware	= /etc/wanpipe/firmware/ppp514.sfm\n",
"Interface 	= V35\n",
"Clocking 	= External\n",
"BaudRate 	= 1540000\n",
"MTU 		= 1500\n",
"UDPPORT 	= 9000\n",
"IP_MODE	= STATIC\n",
"TTL 		= 255\n",
"IGNORE_FRONT_END  = NO\n",
"\n",
"[wp1ppp]\n",
"MULTICAST 	= NO\n",
"PAP       	= NO\n",
"CHAP		= NO\n",
"IPX		= NO\n",
"DYN_INTR_CFG	= NO\n"
);

my @ppp_default_hardware_cfg_e1 = 
(
"#================================================\n",
"# WANPIPE1 Configuration File\n",
"#================================================\n",
"#\n",
"# Note: This file was generated automatically\n",
"#       by /usr/local/wanrouter/wancfg program.\n",
"#\n",
"#       If you want to edit this file, it is\n",
"#       recommended that you use wancfg program\n",
"#       to do so.\n",
"#================================================\n",
"# Sangoma Technologies Inc.\n",
"#================================================\n",
"\n",
"[devices]\n",
"wanpipe1 = WAN_PPP, Comment\n",
"\n",
"[interfaces]\n",
"wp1ppp = wanpipe1, , WANPIPE, Comment\n",
"\n",
"[wanpipe1]\n",
"CARD_TYPE 	= S51X\n",
"S514CPU 	= A\n",
"AUTO_PCISLOT	= YES\n",
"PCISLOT 	= 3\n",
"PCIBUS		= 1\n",
"MEDIA 		= E1\n",
"LCODE 		= HDB3\n",
"FRAME 		= NCRC4\n",
"TE_CLOCK 	= NORMAL\n",
"ACTIVE_CH	= ALL\n",
"LBO 		= 0DB\n",
"Firmware	= /etc/wanpipe/firmware/ppp514.sfm\n",
"Interface 	= V35\n",
"Clocking 	= External\n",
"BaudRate 	= 1540000\n",
"MTU 		= 1500\n",
"UDPPORT 	= 9000\n",
"IP_MODE	= STATIC\n",
"TTL 		= 255\n",
"IGNORE_FRONT_END  = NO\n",
"\n",
"[wp1ppp]\n",
"MULTICAST 	= NO\n",
"PAP       	= NO\n",
"CHAP		= NO\n",
"IPX		= NO\n",
"DYN_INTR_CFG	= NO\n"
);

#
#CHDLC
#
my @chdlc_defaul_ip_cfg =
(
"# Wanrouter interface configuration file\n",
"# name:	wp1chdlc\n",
"#\n",
"DEVICE=wp1chdlc\n",
"IPADDR=\n",
"NETMASK=255.255.255.255\n",
"POINTOPOINT=\n",
"ONBOOT=yes\n",
"GATEWAY=\n"
);


my @chdlc_default_hardware_cfg_serial = 
(
"#================================================\n",
"# WANPIPE1 Configuration File\n",
"#================================================\n",
"#\n",
"# Note: This file was generated automatically\n",
"#       by /usr/local/wanrouter/wancfg program.\n",
"#\n",
"#       If you want to edit this file, it is\n",
"#       recommended that you use wancfg program\n",
"#       to do so.\n",
"#================================================\n",
"# Sangoma Technologies Inc.\n",
"#================================================\n",
"\n",
"[devices]\n",
"wanpipe1 = WAN_CHDLC, Comment\n",
"\n",
"[interfaces]\n",
"wp1chdlc = wanpipe1, , WANPIPE, Comment\n",
"\n",
"[wanpipe1]\n",
"CARD_TYPE 	= S51X\n",
"S514CPU 	= A\n",
"AUTO_PCISLOT	= YES\n",
"PCISLOT 	= 6\n",
"PCIBUS		= 0\n",
"Firmware	= /etc/wanpipe/firmware/cdual514.sfm\n",
"CommPort	= PRI\n",
"Receive_Only	= NO\n",
"Connection	= Permanent\n",
"LineCoding	= NRZ\n",
"LineIdle	= Flag\n",
"Interface 	= V35\n",
"Clocking 	= External\n",
"BaudRate 	= 1540000\n",
"MTU 		= 1500\n",
"UDPPORT 	= 9000\n",
"TTL 		= 255\n",
"IGNORE_FRONT_END  = NO\n",
"\n",
"[wp1chdlc]\n",
"MULTICAST		= NO\n",
"IGNORE_DCD		= NO\n",
"IGNORE_CTS		= NO\n",
"IGNORE_KEEPALIVE	= NO\n",
"HDLC_STREAMING		= NO\n",
"KEEPALIVE_TX_TIMER	= 10000\n",
"KEEPALIVE_RX_TIMER	= 11000\n",
"KEEPALIVE_ERR_MARGIN	= 5\n",
"SLARP_TIMER		= 0\n",
"TRUE_ENCODING_TYPE	= NO\n",
"DYN_INTR_CFG	= NO\n"
);

my @chdlc_default_hardware_cfg_t1 = 
(
"#================================================\n",
"# WANPIPE1 Configuration File\n",
"#================================================\n",
"#\n",
"# Note: This file was generated automatically\n",
"#       by /usr/local/wanrouter/wancfg program.\n",
"#\n",
"#       If you want to edit this file, it is\n",
"#       recommended that you use wancfg program\n",
"#       to do so.\n",
"#================================================\n",
"# Sangoma Technologies Inc.\n",
"#================================================\n",
"\n",
"[devices]\n",
"wanpipe1 = WAN_CHDLC, Comment\n",
"\n",
"[interfaces]\n",
"wp1chdlc = wanpipe1, , WANPIPE, Comment\n",
"\n",
"[wanpipe1]\n",
"CARD_TYPE 	= S51X\n",
"S514CPU 	= A\n",
"AUTO_PCISLOT	= YES\n",
"PCISLOT 	= 3\n",
"PCIBUS		= 1\n",
"MEDIA 		= T1\n",
"LCODE 		= B8ZS\n",
"FRAME 		= ESF\n",
"TE_CLOCK 	= NORMAL\n",
"ACTIVE_CH	= ALL\n",
"LBO 		= 0DB\n",
"Firmware	= /etc/wanpipe/firmware/cdual514.sfm\n",
"CommPort	= PRI\n",
"Receive_Only	= NO\n",
"Connection	= Permanent\n",
"LineCoding	= NRZ\n",
"LineIdle	= Flag\n",
"Interface 	= V35\n",
"Clocking 	= External\n",
"BaudRate 	= 1540000\n",
"MTU 		= 1500\n",
"UDPPORT 	= 9000\n",
"TTL 		= 255\n",
"IGNORE_FRONT_END  = NO\n",
"\n",
"[wp1chdlc]\n",
"MULTICAST		= NO\n",
"IGNORE_DCD		= NO\n",
"IGNORE_CTS		= NO\n",
"IGNORE_KEEPALIVE	= NO\n",
"HDLC_STREAMING		= NO\n",
"KEEPALIVE_TX_TIMER	= 10000\n",
"KEEPALIVE_RX_TIMER	= 11000\n",
"KEEPALIVE_ERR_MARGIN	= 5\n",
"SLARP_TIMER		= 0\n",
"TRUE_ENCODING_TYPE	= NO\n",
"DYN_INTR_CFG	= NO\n",
);

my @chdlc_default_hardware_cfg_e1 = 
(
"#================================================\n",
"# WANPIPE1 Configuration File\n",
"#================================================\n",
"#\n",
"# Note: This file was generated automatically\n",
"#       by /usr/local/wanrouter/wancfg program.\n",
"#\n",
"#       If you want to edit this file, it is\n",
"#       recommended that you use wancfg program\n",
"#       to do so.\n",
"#================================================\n",
"# Sangoma Technologies Inc.\n",
"#================================================\n",
"\n",
"[devices]\n",
"wanpipe1 = WAN_CHDLC, Comment\n",
"\n",
"[interfaces]\n",
"wp1chdlc = wanpipe1, , WANPIPE, Comment\n",
"\n",
"[wanpipe1]\n",
"CARD_TYPE 	= S51X\n",
"S514CPU 	= A\n",
"AUTO_PCISLOT	= YES\n",
"PCISLOT 	= 3\n",
"PCIBUS		= 1\n",
"MEDIA 		= E1\n",
"LCODE 		= HDB3\n",
"FRAME 		= NCRC4\n",
"TE_CLOCK 	= NORMAL\n",
"ACTIVE_CH	= ALL\n",
"LBO 		= 0DB\n",
"Firmware	= /etc/wanpipe/firmware/cdual514.sfm\n",
"CommPort	= PRI\n",
"Receive_Only	= NO\n",
"Connection	= Permanent\n",
"LineCoding	= NRZ\n",
"LineIdle	= Flag\n",
"Interface 	= V35\n",
"Clocking 	= External\n",
"BaudRate 	= 1540000\n",
"MTU 		= 1500\n",
"UDPPORT 	= 9000\n",
"TTL 		= 255\n",
"IGNORE_FRONT_END  = NO\n",
"\n",
"[wp1chdlc]\n",
"MULTICAST		= NO\n",
"IGNORE_DCD		= NO\n",
"IGNORE_CTS		= NO\n",
"IGNORE_KEEPALIVE	= NO\n",
"HDLC_STREAMING		= NO\n",
"KEEPALIVE_TX_TIMER	= 10000\n",
"KEEPALIVE_RX_TIMER	= 11000\n",
"KEEPALIVE_ERR_MARGIN	= 5\n",
"SLARP_TIMER		= 0\n",
"TRUE_ENCODING_TYPE	= NO\n",
"DYN_INTR_CFG	= NO\n",
);

#######################################################################
#Main page for WANPIPE confiuration.
#
package MAIN_PAGE;

	sub new
	{
		my $proto = shift;
             	my $class = ref($proto) || $proto;
		my $self = {};
		$self->{'wan_device'} = undef;
		$self->{'action'} = "home_page";

		bless ($self,$class);
		return $self;
	}

	sub display
	{

		print "<br><b>WANPIPE WEBCFG</b><br><br>"; 
		
		if(!open(DEFAULT_WANPIPE_CONF_FILE,  $default_wanpipe_conf_file)){
		
			print"<br>Creating new: $default_wanpipe_conf_file<br><br>";
		
			#If wanpipe1.conf does not exist it is the first time
			#configuration is created. Run the hardware probe
			#to detect a Sangoma card.
			#
			#If card is replaced with a card of a different 
			#type delete wanpipe1.conf
			#and run the configuration page again.
			
			#print "Warning: Failed open $default_wanpipe_conf_file : $! <br>";
			#print "Using defaults... <br>";

			#detect a card
			if(hardware_probe()){
				return 1;
			}

			#Now, when we know the card type:
			#if ADSL, show default ADSL configuration,
			#if other card, select Frame Relay as default protocol.
			
			if($card_type eq $card_type_serial){
				@conf_file_data = @fr_default_hardware_cfg_serial;
			}elsif($card_type eq $card_type_adsl){
				@conf_file_data = @adsl_default_hardware_cfg;
			}else{
				if ($card_arch eq $card_arch_aft){
					@conf_file_data = @aft_default_hardware_cfg_t1;	
				}else{
					@conf_file_data = @fr_default_hardware_cfg_t1;
				}
			}
		}else{	
			print"<br>Editing existing: $default_wanpipe_conf_file<br><br>";

			#$card_type=$card_type_unknown;
			#read configuration from the default .conf file
			#read the whole file into the array
			@conf_file_data = <DEFAULT_WANPIPE_CONF_FILE>;
		}
		
		show_hardware_configuration();

		#get IP information for this interface
		
		$ip_conf_file = "?";

		if($wan_protocol == $protocol_chdlc){
			$ip_conf_file = $default_chdlc_interface;
			$chdlc_radio_button_state = "checked";
		}elsif($wan_protocol == $protocol_fr){
			$ip_conf_file = $default_fr_interface;
			$fr_radio_button_state = "checked";
		}elsif($wan_protocol == $protocol_ppp){
			$ip_conf_file = $default_ppp_interface;
			$ppp_radio_button_state = "checked";
		}elsif($wan_protocol == $protocol_adsl){
			$ip_conf_file = $default_adsl_interface;
			get_adsl_pap_chap_ppp_cfg();
		}

		if ($card_arch eq $card_arch_aft){
			$ip_conf_file = $default_aft_interface;
		}
		
		if(!open(IP_CONF_FILE_HANDLE,  $ip_conf_file)){
			print "Can't open IP configuration file : $ip_conf_file : $! <br>";
			print "Loading default IP ($wan_protocol) configuration. <br>";
			
			show_ip_configuration(@adsl_defaul_ip_cfg);
		}else{
			#read the whole file into the array
			@ip_conf_file_data = <IP_CONF_FILE_HANDLE>;

			show_ip_configuration(@ip_conf_file_data);
		}
		
		print "<form method=\"POST\" action\"/cgi-bin/wanpipe_cfg.cgi\">
		       <input type=\"hidden\">";
		  
		display_appropriate_options();

		print "<input type=\"submit\" name=\"page\" value=\"Save\">";
		print "</form>";

		return 0;
	}

	sub show_hardware_configuration
	{
		#print "show_hardware_configuration() <br>";
		$card_arch=$card_arch_s514;
	
		#scan through array
		foreach(@conf_file_data){
			#print each line in the file for debugging
			#print "$_<br>";

			if($_ =~ /WAN_FR/){
				#print "this is a Frame Relay interface <br>";	
				$wan_protocol = $protocol_fr;
			}elsif($_ =~ /WAN_CHDLC/){
				#print "this is a CHDLC interface <br>";	
				$wan_protocol = $protocol_chdlc;
			}elsif($_ =~ /WAN_PPP/){
				#print "this is a PPP interface <br>";	
				$wan_protocol = $protocol_ppp;
			}elsif($_ =~ /WAN_ADSL/){
				#print "this is an ADSL interface <br>";	
				$wan_protocol = $protocol_adsl;
			}elsif($_ =~ /WAN_AFT/){
				$card_arch=$card_arch_aft;
			}

			if ($card_arch eq $card_arch_aft){
				if ($_ =~ /MP_FR/){
					$wan_protocol = $protocol_fr;
				}elsif ($_ =~ /MP_CHDLC/){
					$wan_protocol = $protocol_chdlc;
				}elsif ($_ =~ /MP_PPP/){
					$wan_protocol = $protocol_ppp;
				}
			}

			#extract Active Channels string
			if($_ =~ /ACTIVE_CH/){
				#split the string
				my @tmp_string = split /\s+/, $_;
				#print "Active Chann str : $_ <br>";
				$active_channels=$tmp_string[2];
			}

			#order is important!
			if($_ =~ /CARD_TYPE/){
				#split the string
				my @card_type_string = split /\s+/, $_;

				#print "Card type str : $_ <br>";

				if($card_type_string[2] eq "S518"){
					$card_type=$card_type_adsl;
				}elsif($card_type_string[2] eq "AFT"){
					$card_type=$card_type_t1;
					$card_arch=$card_arch_aft;
				}else{	
					$card_type=$card_type_serial;
				}
			}

			if($_ =~ /MEDIA/){
				#split the string
				my @media_string = split /\s+/, $_;

				#print "Media str : $_ <br>";

				if($media_string[2] eq "T1"){
					$card_type=$card_type_t1;
					$T1_radio_button_state = "checked";
				}

				if($media_string[2] eq "E1"){
					$card_type=$card_type_e1;
					$E1_radio_button_state = "checked";
				}
			}
				
			#for frame relay there should be Signalling
			if($_ =~ /Signalling/){
				#split the string
				my @signall_string = split /\s+/, $_;

				#print "Signalling str : $_ <br>";

				if($signall_string[2] eq "ANSI"){
					$fr_ansi_radio_button_state  = "checked";
				}elsif($signall_string[2] eq "Q933"){
					$fr_Q933_radio_button_state = "checked";
				}else{
					$fr_lmi_radio_button_state = "checked";
				}
			}
			#for a serial card there should be Interface
			if($_ =~ /Interface/){
				#split the string
				my @electrical_interface_string = split /\s+/, $_;

				#print "Interface str : $_ <br>";
				if($electrical_interface_string[2] eq "V35"){
					$V35_radio_button_state = "checked";
				}else{
					$RS232_radio_button_state = "checked";
				}
			}

			#for ADSL card there should be EncapMode
			if($_ =~ /EncapMode/){
				#split the string
				my @encap_mode_string = split /\s+/, $_;

				#print "EncapMode : $_ <br>";

				if($encap_mode_string[2] eq "ETH_LLC_OA"){
					$ETH_LLC_OA_state = "checked";
				}elsif($encap_mode_string[2] eq "ETH_VC_OA"){
					$ETH_VC_OA_state = "checked";
				}elsif($encap_mode_string[2] eq "IP_LLC_OA"){
					$IP_LLC_OA_state = "checked";
				}elsif($encap_mode_string[2] eq "IP_VC_OA"){
					$IP_VC_OA_state = "checked";
				}elsif($encap_mode_string[2] eq "PPP_LLC_OA"){
					$PPP_LLC_OA_state = "checked";
				}elsif($encap_mode_string[2] eq "PPP_VC_OA"){
					$PPP_VC_OA_state = "checked";
				}
			}
			#for ADSL : ATM_AUTOCFG 
			if($_ =~ /ATM_AUTOCFG/){

				my @atm_autocfg = split /\s+/, $_;

				if($atm_autocfg[2] eq "YES"){
					$atm_vpi_vci_autocfg="checked";
					$atm_vpi="AUTO";
					$atm_vci="AUTO";
				}elsif($atm_autocfg[2] eq "NO"){
					$atm_vpi_vci_autocfg="";
				}
			}

			#if not auto read them
			if($_ =~ /Vpi/ && $atm_vpi_vci_autocfg ne "checked" ){
				my @atm_vpi_cfg = split /\s+/, $_;
				$atm_vpi = $atm_vpi_cfg[2];
			}

			if($_ =~ /Vci/ && $atm_vpi_vci_autocfg ne "checked" ){
				my @atm_vci_cfg = split /\s+/, $_;
				$atm_vci = $atm_vci_cfg[2];
			}

		}#foreach()
	}

	sub show_ip_configuration
	{
		#print "in show_ip_configuration() <br>";

		my @ip_conf_array = @_;

		#scan through array
		foreach(@ip_conf_array){
				
			#print each line in the file for debugging
			#print "$_<br>";
	
			if($_ =~ /IPADDR/){
				#now split the string
				my @ip_string = split /\=+/, $_;
				$local_ip_addr = $ip_string[1];
			}

			if($_ =~ /POINTOPOINT/){
				#now split the string
				my @ptop_string = split /\=+/, $_;
				$remote_ip_addr = $ptop_string[1];
			}

			if($_ =~ /NETMASK/){
				#now split the string
				my @netmask_string = split /\=+/, $_;
				$netmask = $netmask_string[1];
			}

			if($_ =~ /GATEWAY/){
				#now split the string
				my @gateway_string = split /\=+/, $_;
				$gateway_ip_addr = $gateway_string[1];
			}

		}#foreach()
	}

	sub get_adsl_pap_chap_ppp_cfg
	{	#
		#There can be more than one line in the PPP '-secrets' files
		#here only the first one is used.
		#Reimplement as needed!!
		#
		if(!open(PAP_SECRETS_FILE, $pap_secrets_file)){
			print "Can't open $pap_secrets_file : $! !!<br>";
		}

		if(!open(CHAP_SECRETS_FILE, $chap_secrets_file)){
			print "Can't open $chap_secrets_file : $! !!<br>";

		}else{
			@chap_file_data = <CHAP_SECRETS_FILE>;
			my @temp = split /\s+/, $chap_file_data[0];

			$sign_on_ppp = $temp[0];
			#get rid of double qoutes
			$sign_on_ppp = substr($sign_on_ppp, 1, length($sign_on_ppp)-2);
			#print "sign : $sign_on_ppp<br>";

			$password_ppp= $temp[2];
		}
	}

	sub hardware_probe
	{
		#print "in hardware_probe() <br>";

		#Run hwprobe
		my $mod_rc=`/usr/sbin/wanrouter hwprobe`;

		#If hardware probe faild exit
		if ( ! (-e "/proc/net/wanrouter/hwprobe")){
			print "Hardware probe failed - Sangoma WANPIPE modules are not loaded."; 
			return 1;
		}
	
		my @dev_list=`cat /proc/net/wanrouter/hwprobe | grep : | grep PRI | grep CPU=A | cut -d'.' -f2`;
		if ( $#dev_list > 1 ){
			my $num_of_devs=$#dev_list + 1;
			#print 	"Error: Multiple Sangoma cards detected ($num_of_devs cards).
			#	 Maximum allowed is 1 card.<br>"; 
			#return 1;
		}

		my $val = $dev_list[0];

		print "Wanpipe Hardware Probe: <br>    $val<br><br><br>";

		#Initialize card type to t1
		$card_type=$card_type_t1;
		$card_arch=$card_arch_s514;

		if ($val=~/S514-1/ig || $val=~/S514-2/ig){
			$card_type=$card_type_serial;
		}elsif ($val=~/S518/ig){
			$card_type=$card_type_adsl;
		}elsif ($val=~/A101/ig){
			$card_arch=$card_arch_aft;	
			$card_type=$card_type_t1;
		}else{
			#it is already t1e1 but set again for clarity
			$card_type=$card_type_t1;
		}

		#print "<br>Detected $card_type card <br><br>";
		return 0;
	}

	sub AUTOLOAD 
	{
		return 1;
	}

	sub display_appropriate_options
	{
		#print "display_appropriate_options() <br>";

		if ($card_type eq $card_type_serial){
			
			print "Serial card Hardware Section <br>";
	
			print "
				<table border=\"1\" width=\"100%\">
				 <tr>
				  <td width=\"50%\">
				   <input type=\"radio\" 
				    value=\"V35\" $V35_radio_button_state 
				    name=\"interface\">V35
			            <input type=\"radio\" 
				    value=\"RS232\" $RS232_radio_button_state
				    name=\"interface\">RS232
			
				  </td>
<!--
				  <td width=\"50%\">
				   <input type=\"submit\" name=\"page\" 
				   value=\"Advanced_Serial_Card_Configuration\"><br>
				  </td>
-->
				 </tr>
				</table>
			";

			print "<br>";

		}elsif ($card_type eq $card_type_adsl){
			#No Hardware options for ADSL card
		}else{
			#t1e1 card			
			print "<input type=\"radio\" value=\"T1\" $T1_radio_button_state 
				name=\"interface\">T1&nbsp&nbsp
			       <input type=\"radio\" value=\"E1\" $E1_radio_button_state
				name=\"interface\">E1<br>";
			
			if($active_channels eq "?"){
				$active_channels="ALL";
			}

			print "	<table border=\"1\" width=\"100%\">
				 <tr>
				  <td width=\"50%\">
				   <input type=\"textbox\" value=$active_channels 
				   name=\"active_channels\">Active Channels
				  </td>
<!--
				  <td width=\"50%\">
				   <input type=\"submit\" name=\"page\" 
				   value=\"Advanced_Channels_Configuration\"><br>
				  </td>
-->
				 </tr>
				</table>
			       <br>
			";
		}
		#
		#Insert Protocol Input fields
		#
		#
		
		if ($card_arch eq $card_arch_aft){
			
			print"  
				<input type=\"hidden\" value=\"AFT\"
				       name=\"arch\">

				<table border=\"1\" width=\"100%\">
				 <tr>
				  <td width=\"50%\">

				     <input type=\"radio\" 
				     value=\"WAN_FR\"  $fr_radio_button_state
				     name=\"protocol\">Frame Relay&nbsp&nbsp&nbsp

				     <input type=\"radio\"
				     value=\"ANSI\" $fr_ansi_radio_button_state 
				     name=\"signalling\">ANSI&nbsp

				     <input type=\"radio\" 
				     value=\"LMI\" $fr_lmi_radio_button_state
				     name=\"signalling\">LMI&nbsp

				     <input type=\"radio\" 
				     value=\"Q933\" $fr_Q933_radio_button_state
				     name=\"signalling\" size=500>Q933

				  </td>

<!--
				  <td width=\"50%\">

				   <input type=\"submit\" name=\"page\"
				   value=\"Advanced_Frame_Relay_Configuration\"><br>

				  </td>
-->
				  </tr>
				</table>

				
				<table border=\"1\" width=\"100%\">
				 <tr>
				  <td width=\"50%\">

				   <input type=\"radio\" value=\"WAN_PPP\" $ppp_radio_button_state
				   name=\"protocol\">PPP

				  </td>
<!--	
				  <td width=\"50%\">
				   <input type=\"submit\" name=\"page\" 
				   value=\"Advanced_PPP_Configuration\"><br>

				  </td>
-->
				  </tr>
				</table>

				<table border=\"1\" width=\"100%\">
				 <tr>
				  <td width=\"50%\">

				   <input type=\"radio\" 
				   value=\"WAN_CHDLC\" $chdlc_radio_button_state
				   name=\"protocol\">CHDLC

				  </td>
<!--
				  <td width=\"50%\">

				   <input type=\"submit\" name=\"page\" size=\"100\"
				   value=\"Advanced_CHDLC_Configuration\"><br>

				  </td>
-->
				</tr>
				</table>
			";


		}elsif ($card_type ne $card_type_adsl){

			if ($card_arch eq $card_arch_aft){
				print"<input type=\"hidden\" value=\"AFT\"
					       name=\"arch\"> ";

			}else{
				print"<input type=\"hidden\" value=\"S514\"
					       name=\"arch\"> ";
			}
		
			print"  

				<input type=\"hidden\" value=\"S514\"
				       name=\"arch\">

				<table border=\"1\" width=\"100%\">
				 <tr>
				  <td width=\"50%\">

				     <input type=\"radio\" 
				     value=\"WAN_FR\"  $fr_radio_button_state
				     name=\"protocol\">Frame Relay&nbsp&nbsp&nbsp

				     <input type=\"radio\"
				     value=\"ANSI\" $fr_ansi_radio_button_state 
				     name=\"signalling\">ANSI&nbsp

				     <input type=\"radio\" 
				     value=\"LMI\" $fr_lmi_radio_button_state
				     name=\"signalling\">LMI&nbsp

				     <input type=\"radio\" 
				     value=\"Q933\" $fr_Q933_radio_button_state
				     name=\"signalling\" size=500>Q933

				  </td>
<!--
				  <td width=\"50%\">

				   <input type=\"submit\" name=\"page\"
				   value=\"Advanced_Frame_Relay_Configuration\"><br>

				  </td>
-->
				</tr>
				</table>

				
				<table border=\"1\" width=\"100%\">
				 <tr>
				  <td width=\"50%\">

				   <input type=\"radio\" value=\"WAN_PPP\" $ppp_radio_button_state
				   name=\"protocol\">PPP

				  </td>
<!-- 				
				  <td width=\"50%\">
				   <input type=\"submit\" name=\"page\" 
				   value=\"Advanced_PPP_Configuration\"><br>

				</td>
-->
				 </tr>
				</table>

				<table border=\"1\" width=\"100%\">
				 <tr>
				  <td width=\"50%\">

				   <input type=\"radio\" 
				   value=\"WAN_CHDLC\" $chdlc_radio_button_state
				   name=\"protocol\">CHDLC

				  </td>

<!--
				  <td width=\"50%\">

				   <input type=\"submit\" name=\"page\" size=\"100\"
				   value=\"Advanced_CHDLC_Configuration\"><br>

				  </td>
-->
				</tr>
				</table>
			";
		}else{
			print"
				<input type=\"hidden\" value=\"WAN_ADSL\"
				name=\"protocol\">

				<input type=\"hidden\" value=\"S518\"
				       name=\"arch\">

				<br>
				<input type=\"radio\" value=\"ETH_LLC_OA\" $ETH_LLC_OA_state
				name=\"encapmode\">Bridged Ethernet LLC Over ATM<br>

				<input type=\"radio\" value=\"ETH VC_OA\" $ETH_VC_OA_state
				name=\"encapmode\">Bridged Ethernet VC Over ATM<br>

				<input type=\"radio\" value=\"IP_LLC_OA\" $IP_LLC_OA_state
				name=\"encapmode\">Classical IP LLC Over ATM<br>

				<input type=\"radio\" value=\"IP_VC_OA\" $IP_VC_OA_state
				name=\"encapmode\">Routed IP VC Over ATM<br>

				<input type=\"radio\" value=\"PPP_LLC_OA\" $PPP_LLC_OA_state
				name=\"encapmode\">PPP LLC Over ATM<br> 

				<input type=\"radio\" value=\"PPP_VC_OA\" $PPP_VC_OA_state
				name=\"encapmode\">PPP VC Over ATM<br>

				<input type=\"textbox\" value=\"$sign_on_ppp\" 
				name=\"sign_on_ppp\">Sign on (for PPP)<br>

				<input type=\"password\" value=\"$password_ppp\" 
				name=\"password_ppp\">Password (for PPP)<br>
			";

			print "<br>If you can get the VPI and VCI parameters <br>";
			print "from your ISP it will make the connection <br>";
			print "set-up much quicker. <br>";
			print "Uncheck \"Auto VPI\\VCI\" checkbox below in this case. <br>";
			print "If not, check the \"Auto VPI\\VCI\" checkbox to
			 	enable Auto Configuration.<br>";

			print "	<input type=\"textbox\" value=\"$atm_vpi\" 
				name=\"atm_vpi\">ATM VPI<br>

				<input type=\"textbox\" value=\"$atm_vci\" 
				name=\"atm_vci\">ATM VCI<br>
			";

			print "<input type=\"checkbox\" value=\"yes\" $atm_vpi_vci_autocfg
				name=\"auto_vpi_vci\">Auto VPI\\VCI <br>";
		}

		#Insert IP Input Fields

		print "<br> IP Set-up: <br>";
	
		print "<input type=\"textbox\" value=\"$local_ip_addr\"
			name=\"local_ip\">Local IP Address<br>";	
		print "<input type=\"textbox\" value=\"$remote_ip_addr\"
			name=\"remote_ip\">Remote IP Address<br>";
		print "<input type=\"textbox\" value=\"$netmask\"
			name=\"netmask_ip\">Netmask<br>";
		print "<input type=\"textbox\" value=\"$gateway_ip_addr\"
			name=\"gateway_ip\">Gateway IP Address<br>";

		print "<br>"
	}

#######################################################################
#This class contains all the code for saving configuration,
#when 'Save' button is clicked.
#
package Save;

	sub new
	{
		my $proto = shift;
             	my $class = ref($proto) || $proto;
		my $self = {};

		#print "IN SAVE OBJECT <br>";

		bless ($self,$class);
		return $self;
	}

	sub arch
	{
		my $self = shift;
		if (@_){
			$self->{'arch'}=shift;
			#printf "Save Got Arch %s <br>", $self->{'arch'};

			my $temp_protocol = $self->{'arch'};

			if($temp_protocol eq "AFT"){
				$card_arch = $card_arch_aft;
			}else{
				$card_arch = $card_arch_s514;
			}

			
		}

		return $self->{'arch'};
	}

	sub protocol
	{
		my $self = shift;
		if (@_){
			$self->{'protocol'}=shift;
			#printf "Save Got Protocol %s <br>", $self->{'protocol'};

			my $temp_protocol = $self->{'protocol'};

			if($temp_protocol eq "WAN_FR"){
				#print "this is a Frame Relay interface <br>";	
				$wan_protocol = $protocol_fr;
			}elsif( $temp_protocol eq "WAN_CHDLC"){
				#print "this is a CHDLC interface <br>";	
				$wan_protocol = $protocol_chdlc;
			}elsif( $temp_protocol eq "WAN_PPP"){
				#print "this is a PPP interface <br>";	
				$wan_protocol = $protocol_ppp;
			}elsif( $temp_protocol eq "WAN_ADSL"){
				#print "this is an ADSL interface <br>";	
				$wan_protocol = $protocol_adsl;
				$card_type = $card_type_adsl;
			}
		}
		return $self->{'protocol'};
	}

	sub signalling	
	{
		my $self = shift;
		if (@_){
			$self->{'signalling'}=shift;
			#printf "Save Got Signalling %s <br>", $self->{'signalling'};
		}
		return $self->{'signalling'};
	}

	sub encapmode	
	{
		my $self = shift;
		if (@_){
			$self->{'encapmode'}=shift;
			#printf "Save Got Encapmode %s <br>", $self->{'encapmode'};
		}
		return $self->{'encapmode'};
	}

	sub interface
	{
		my $self = shift;
		if (@_){
			$self->{'interface'}=shift;
			#printf "Save Got interface %s <br>", $self->{'interface'};

			my $tmp_str = $self->{'interface'};

			if($tmp_str eq "V35" || $tmp_str eq "RS232"){
				$card_type = $card_type_serial;
			}elsif($tmp_str eq "T1"){
				$card_type = $card_type_t1;
			}elsif($tmp_str eq "E1"){
				$card_type = $card_type_e1;
			}
		}
		return $self->{'interface'};
	}

	sub active_channels	
	{
		my $self = shift;
		if (@_){
			$self->{'active_channels'}=shift;
			#printf "Save Got Active Channels %s <br>", $self->{'active_channels'};
		}
		return $self->{'active_channels'};
	}

	sub sign_on_ppp
	{
		my $self = shift;
		if (@_){
			$self->{'sign_on_ppp'}=shift;
			#printf "Save Got sign_on_ppp %s <br>", $self->{'sign_on_ppp'};
		}
		return $self->{'sign_on_ppp'};
	}

	sub password_ppp
	{
		my $self = shift;
		if (@_){
			$self->{'password_ppp'}=shift;
			#printf "Save Got password_ppp %s <br>", $self->{'password_ppp'};
		}
		return $self->{'password_ppp'};
	}

	sub atm_vpi
	{
		my $self = shift;
		if (@_){
			$self->{'atm_vpi'}=shift;
			#printf "Save Got atm_vpi %s <br>", $self->{'atm_vpi'};
		}
		return $self->{'atm_vpi'};
	}

	sub atm_vci
	{
		my $self = shift;
		if (@_){
			$self->{'atm_vci'}=shift;
			#printf "Save Got atm_vci %s <br>", $self->{'atm_vci'};
		}
		return $self->{'atm_vci'};
	}

	sub auto_vpi_vci
	{
		my $self = shift;
		if (@_){
			$self->{'auto_vpi_vci'}=shift;
			#printf "Save Got auto_vpi_vci %s <br>", $self->{'auto_vpi_vci'};
		}
		return $self->{'auto_vpi_vci'};
	}

	sub local_ip
	{
		my $self = shift;
		if (@_){
			$self->{'local_ip'}=shift;
			#printf "Save Got local_ip %s <br>", $self->{'local_ip'};
		}
		return $self->{'local_ip'};
	}

	sub remote_ip	
	{
		my $self = shift;
		if (@_){
			$self->{'remote_ip'}=shift;
			#printf "Save Got remote_ip %s <br>", $self->{'remote_ip'};
		}
		return $self->{'remote_ip'};
	}

	sub netmask_ip	
	{
		my $self = shift;
		if (@_){
			$self->{'netmask_ip'}=shift;
			#printf "Save Got netmask_ip %s <br>", $self->{'netmask_ip'};
		}
		return $self->{'netmask_ip'};
	}

	sub gateway_ip
	{
		my $self = shift;
		if (@_){
			$self->{'gateway_ip'}=shift;
			#printf "Save Got gateway_ip %s <br>", $self->{'gateway_ip'};
		}
		return $self->{'gateway_ip'};
	}
	
	sub AUTOLOAD 
	{
		my $self = shift;
		my $value = shift;

		#print "SAVE Autoload Value=$value <br>";
		return 1;
	}

	sub display
	{
		#print "Save : in display() <br>";
		return 0;
	}

	#save updated configuration into appropriate files.
	sub DESTROY
	{
		my $self = shift;
		my $i=0;

		#########################################
		#wanpipe1.conf file
		if(!open(DEFAULT_WANPIPE_CONF_FILE, $default_wanpipe_conf_file)){
			#print "Can't open $default_wanpipe_conf_file : $! <br>";
			#print "Save Using defaults ...<br>";

			reset_to_default_configuration();

		}else{	
			#read the whole wanpipe1.conf file into the array
			@conf_file_data = <DEFAULT_WANPIPE_CONF_FILE>;
			my $old_protocol;
			my $new_protocol;

			$new_protocol = $self->{'protocol'};
			#print "new_protocol : $new_protocol <br>";

			for($i=0; $i < @conf_file_data ; $i++){
				#search the protocol

				if($conf_file_data[$i] =~ /WAN_FR/){
					$old_protocol = "WAN_FR";
				}
				if($conf_file_data[$i] =~ /WAN_CHDLC/){
					$old_protocol = "WAN_CHDLC";
				}
				if($conf_file_data[$i] =~ /WAN_PPP/){
					$old_protocol = "WAN_PPP";
				}
				if($conf_file_data[$i] =~ /WAN_ADSL/){
					$old_protocol = "WAN_ADSL";
				}				
				if($conf_file_data[$i] =~ /WAN_AFT/){
					$old_protocol = "WAN_AFT";
				}	
				
			}
			#print "old_protocol : $old_protocol <br>";

			my $old_media_type;
			my $new_media_type = $self->{'interface'};

			for($i=0; $i < @conf_file_data ; $i++){
				#search the media type
				if($conf_file_data[$i] =~ /MEDIA/){
					#split the string
					my @interface_string = split /\s+/, $conf_file_data[$i];

					#print "interface_string str : $conf_file_data[$i] <br>";
					#create the string to write into the file
					$old_media_type = $interface_string[2];
				}
			}
			#print "old_media_type : $old_media_type <br>";
			#print "new_media_type : $new_media_type <br>";

			#if user changed protocol or media type use defaults
			if($new_protocol ne $old_protocol ||
			   $old_media_type ne $new_media_type)
			{
				reset_to_default_configuration();
			}
		}

		############################################

		if ($card_arch eq $card_arch_aft){
			for($i=0; $i < @conf_file_data ; $i++){
							
				if($conf_file_data[$i] =~ /Protocol/i){
					my $tmp_prot =  $self->{'protocol'};
					#print "Protocol String is: $conf_file_data[$i] <br>";
					#create the string to write into the file
					$conf_file_data[$i]=
						"PROTOCOL = " . $prot_hash->{$tmp_prot} . "\n";
				}
			}
		}

		############################################
		for($i=0; $i < @conf_file_data ; $i++){
						
			if($conf_file_data[$i] =~ /Signalling/){
				#split the string
				my @signalling_string = split /\s+/, $conf_file_data[$i];

				#print "signalling_string str : $conf_file_data[$i] <br>";
				#create the string to write into the file
				$conf_file_data[$i]=
					"Signalling = " . $self->{'signalling'} . "\n";
			}
		}
		############################################
		for($i=0; $i < @conf_file_data ; $i++){
			#replace active channels with user's stuff
				
			if($conf_file_data[$i] =~ /ACTIVE_CH/){
				#split the string
				my @active_ch_string = split /\s+/, $conf_file_data[$i];

				#print "active_ch_string str : $conf_file_data[$i] <br>";
				#create the string to write into the file
				$conf_file_data[$i]=
					"ACTIVE_CH = " . $self->{'active_channels'} . "\n";
			}
		}
		############################################
		for($i=0; $i < @conf_file_data ; $i++){

			my $tmp_str = $self->{'interface'};

			if($tmp_str eq "V35" || $tmp_str eq "RS232"){
				if($conf_file_data[$i] =~ /Interface/){
					#split the string
					my @interface_string = split /\s+/, $conf_file_data[$i];

					#print "interface_string str : $conf_file_data[$i] <br>";
					#create the string to write into the file
					$conf_file_data[$i]=
						"Interface = " . $self->{'interface'} . "\n";
				}
			}elsif($tmp_str eq "T1" || $tmp_str eq "E1"){
				if($conf_file_data[$i] =~ /MEDIA/){
					#split the string
					my @interface_string = split /\s+/, $conf_file_data[$i];

					#print "interface_string str : $conf_file_data[$i] <br>";
					#create the string to write into the file
					$conf_file_data[$i]=
						"MEDIA = " . $self->{'interface'} . "\n";
				}
			}
		}#for()
		############################################
		my $atm_autocfg_string = $self->{'auto_vpi_vci'};

		for($i=0; $i < @conf_file_data ; $i++){
				
			if($conf_file_data[$i] =~ /ATM_AUTOCFG/){
				#split the string
				#print "atm_autocfg_string : $atm_autocfg_string <br>";
				#create the string to write into the file
				if($atm_autocfg_string eq "yes"){
					$conf_file_data[$i]="ATM_AUTOCFG = YES\n";
				}else{
					$conf_file_data[$i]="ATM_AUTOCFG = NO\n";
				}
			}
		}
		############################################
		for($i=0; $i < @conf_file_data ; $i++){
			if($conf_file_data[$i] =~ /EncapMode/){
				$conf_file_data[$i]="EncapMode = " . $self->{'encapmode'} . "\n";
			}
		}
	
		#only 2 lines are different for encapmodes	
		my $encap_mode = $self->{'encapmode'};

		if($encap_mode eq "IP_LLC_OA" || $encap_mode eq "IP_VC_OA"){
			my $found = 0;
			for($i=0; $i < @conf_file_data ; $i++){
				if($conf_file_data[$i] =~ /interfaces/){
					$conf_file_data[$i+1]=
						"wp1adsl = wanpipe1, , WANPIPE, Comment\n";
					$found = 1;
				}
			}
			#if not found append to the end of the file
			if($found == 0){
				$conf_file_data[$#conf_file_data + 1]="\n\n[interfaces]\n";

				$conf_file_data[$#conf_file_data + 2]=
						"wp1adsl = wanpipe1, , WANPIPE, Comment\n";
			}
		}elsif($encap_mode eq "ETH_LLC_OA" || $encap_mode eq "ETH_VC_OA"){
			my $found = 0;
			for($i=0; $i < @conf_file_data ; $i++){
				if($conf_file_data[$i] =~ /interfaces/){
					$conf_file_data[$i+1]=
						"wp1adsl = wanpipe1, , PPPoE, Comment\n";
					$found = 1;
				}
			}
			#if not found append to the end of the file
			if($found == 0){
				$conf_file_data[$#conf_file_data + 1]="\n\n[interfaces]\n";

				$conf_file_data[$#conf_file_data + 2]=
						"wp1adsl = wanpipe1, , PPPoE, Comment\n";
			}
		
		}elsif( $encap_mode eq  "PPP_LLC_OA" || $encap_mode eq  "PPP_VC_OA"){
			for($i=0; $i < @conf_file_data ; $i++){
				#remove 2 lines
				if($conf_file_data[$i] =~ /interfaces/){
					$conf_file_data[$i]=" ";
					$conf_file_data[$i+1]=" ";
					
				}
			}
		}
		############################################
		for($i=0; $i < @conf_file_data ; $i++){
				
			if($conf_file_data[$i] =~ /Vci/){
				if($atm_autocfg_string eq "yes"){
					$conf_file_data[$i]= "Vci = AUTO\n";
				}else{
					$conf_file_data[$i]=
						"Vci = " . $self->{'atm_vci'} . "\n";		
				}
			}

			if($conf_file_data[$i] =~ /Vpi/){
				if($atm_autocfg_string eq "yes"){
					$conf_file_data[$i]= "Vpi = AUTO\n";
				}else{
					$conf_file_data[$i]=
						"Vpi = " . $self->{'atm_vpi'} . "\n";		
				}
			}
		}
		############################################
		#now open aproppriate IP configuration file
		#
		
		if ($card_arch eq $card_arch_aft){
			$ip_conf_file = $default_aft_interface;
		}else{
			if($wan_protocol == $protocol_chdlc){
				$ip_conf_file = $default_chdlc_interface;
			}elsif($wan_protocol == $protocol_fr){
				$ip_conf_file = $default_fr_interface;
			}elsif($wan_protocol == $protocol_ppp){
					$ip_conf_file = $default_ppp_interface;
			}elsif($wan_protocol == $protocol_adsl){
				$ip_conf_file = $default_adsl_interface;
				#get_adsl_pap_chap_ppp_cfg();
			}
		}
			
		##############################################
		#ip configuration file
		if(!open(IP_CONF_FILE, $ip_conf_file)){
			print "Can't open file : $ip_conf_file : $! <br>";
			print "Using default configuration... <br>";

			if($wan_protocol == $protocol_chdlc){
				@ip_conf_file_data = @chdlc_defaul_ip_cfg;
			}elsif($wan_protocol == $protocol_fr){
				@ip_conf_file_data = @fr_defaul_ip_cfg;
			}elsif($wan_protocol == $protocol_ppp){
				@ip_conf_file_data = @ppp_defaul_ip_cfg;
			}elsif($wan_protocol == $protocol_adsl){
				@ip_conf_file_data = @adsl_defaul_ip_cfg;
			}
		}else{	
			#read the whole ip conf file into the array
			@ip_conf_file_data = <IP_CONF_FILE>;
		}

		############################################
		for($i=0; $i < @ip_conf_file_data ; $i++){
			#replace local IP with user's stuff
				
			if($ip_conf_file_data[$i] =~ /IPADDR/){
				#split the string
				my @ip_string = split /\s+/, $ip_conf_file_data[$i];

				#print "local ip_string str : $ip_conf_file_data[$i] <br>";
				#create the string to write into the file
				$ip_conf_file_data[$i]=
					"IPADDR=" . $self->{'local_ip'} . "\n";
			}
		}
		############################################
		for($i=0; $i < @ip_conf_file_data ; $i++){
			if($ip_conf_file_data[$i] =~ /POINTOPOINT/){
				#split the string
				my @ip_string = split /\s+/, $ip_conf_file_data[$i];

				#print "remote ip str : $ip_conf_file_data[$i] <br>";
				#create the string to write into the file
				$ip_conf_file_data[$i]=
					"POINTOPOINT=" . $self->{'remote_ip'} . "\n";
			}
		}
		############################################
		for($i=0; $i < @ip_conf_file_data ; $i++){
			if($ip_conf_file_data[$i] =~ /NETMASK/){
				#split the string
				my @ip_string = split /\s+/, $ip_conf_file_data[$i];

				#print "netmask str : $ip_conf_file_data[$i] <br>";
				#create the string to write into the file
				$ip_conf_file_data[$i]=
					"NETMASK=" . $self->{'netmask_ip'} . "\n";
			}
		}
		############################################
		my $found_gateway_entry=0;
		for($i=0; $i < @ip_conf_file_data ; $i++){
			if($ip_conf_file_data[$i] =~ /GATEWAY/){
				#split the string
				my @ip_string = split /\s+/, $ip_conf_file_data[$i];

				#print "gateway str : $ip_conf_file_data[$i] <br>";
				#create the string to write into the file
				$ip_conf_file_data[$i]=
					"GATEWAY=" . $self->{'gateway_ip'} . "\n";
				$found_gateway_entry=1;
			}
		}

		if($found_gateway_entry == 0){
			#if was not found, append at the end of the file
			$ip_conf_file_data[$#ip_conf_file_data+1]=
				"GATEWAY=" . $self->{'gateway_ip'} . "\n";
		}
		############################################
		#Now reopen the file for writing. Note that this will
		#delete the contants of the file (it is trancated to zero length).
		my $file_for_writing = ">" . $default_wanpipe_conf_file;
 	
		if(!open(DEFAULT_WANPIPE_CONF_FILE, $file_for_writing)){
			print "Can't open $default_wanpipe_conf_file for writing : $! <br>";
		}else{
			#wanpipe1.conf
			print "********************************************<br>";
			print "$default_wanpipe_conf_file will be saved as follows: <br>";
			print "********************************************<br>";
			#write configuration to the file
			foreach(@conf_file_data){
				print "$_ <br>";
				print DEFAULT_WANPIPE_CONF_FILE "$_";
			}
		}
		############################################
		#do the same for IP configuration file
		$file_for_writing = ">" . $ip_conf_file;
 
		if(!open(IP_CONF_FILE, $file_for_writing)){
			print "Can't open $ip_conf_file for writing : $! <br>";
		}else{
			print "<br><br>";
			print "********************************************<br>";
			print "$ip_conf_file will be saved as follows: <br>";
			print "********************************************<br>";
			foreach(@ip_conf_file_data){
				print "$_ <br>";
				print IP_CONF_FILE "$_";
			}
		}

		if($wan_protocol == $protocol_adsl)
		{	#
			#Here save 'sign_on_ppp' and 'password_ppp'.
			#The commented code will replace the contents
			#of the '-secrets' files with one line only!
			#All others will be removed, reimplement it as needed.
			#
=start ARBITRARYTEXT

			$file_for_writing = ">" . $pap_secrets_file;
			my $tmp_str = "\"$self->{'sign_on_ppp'}\"" . "\t*\t" . 
				$self->{'password_ppp'} . "\t*";

			if(!open(PAP_SECRETS_FILE, $file_for_writing)){
				print "Can't open $pap_secrets_file for writing : $! !!<br>";
			}else{
				print PAP_SECRETS_FILE $tmp_str;
			}

			$file_for_writing = ">" . $chap_secrets_file;
			if(!open(CHAP_SECRETS_FILE, $file_for_writing)){
				print "Can't open $chap_secrets_file for writing : $! !!<br>";

			}else{
				print CHAP_SECRETS_FILE $tmp_str;
			}
=end ARBITRARYTEXT
=cut
		}

	}

	sub reset_to_default_configuration
	{
		#print "<br>reset_to_default_configuration() <br>";
		#print "prot: $wan_protocol <br>";
		#print "card type : $card_type <br>";
		#print "card arch : $card_arch <br>";

		if($wan_protocol == $protocol_chdlc){

			if ($card_arch eq $card_arch_aft){
				if($card_type eq $card_type_t1){
					@conf_file_data = @aft_default_hardware_cfg_t1;
				}elsif($card_type eq $card_type_e1){
					@conf_file_data = @aft_default_hardware_cfg_e1;
				}
			}else{
				if($card_type eq $card_type_serial){
					@conf_file_data = @chdlc_default_hardware_cfg_serial;
				}elsif($card_type eq $card_type_t1){
					@conf_file_data = @chdlc_default_hardware_cfg_t1;
				}elsif($card_type eq $card_type_e1){
					@conf_file_data = @chdlc_default_hardware_cfg_e1;
				}
			}
		}elsif($wan_protocol == $protocol_fr){
			if ($card_arch eq $card_arch_aft){
				if($card_type eq $card_type_t1){
					@conf_file_data = @aft_default_hardware_cfg_t1;
				}elsif($card_type eq $card_type_e1){
					@conf_file_data = @aft_default_hardware_cfg_e1;
				}
			}else{
				if($card_type eq $card_type_serial){
					@conf_file_data = @fr_default_hardware_cfg_serial;
				}elsif($card_type eq $card_type_t1){
					@conf_file_data = @fr_default_hardware_cfg_t1;
				}elsif($card_type eq $card_type_e1){	
					@conf_file_data = @fr_default_hardware_cfg_e1;
				}
			}
		}elsif($wan_protocol == $protocol_ppp){

			if ($card_arch eq $card_arch_aft){
				if($card_type eq $card_type_t1){
					@conf_file_data = @aft_default_hardware_cfg_t1;
				}elsif($card_type eq $card_type_e1){
					@conf_file_data = @aft_default_hardware_cfg_e1;
				}
			}else{
				if($card_type eq $card_type_serial){
					@conf_file_data = @ppp_default_hardware_cfg_serial;
				}elsif($card_type eq $card_type_t1){
					@conf_file_data = @ppp_default_hardware_cfg_t1;
				}elsif($card_type eq $card_type_e1){
					@conf_file_data = @ppp_default_hardware_cfg_e1;
				}
			}
		}elsif($wan_protocol == $protocol_adsl){
			@conf_file_data = @adsl_default_hardware_cfg;

		}
	}

#######################################################################
#This is a sample class for an 'Advanced_?' button.
#Note that class name can not have spaces in it's name
#so button will have underscores instead of spaces.
#
package Advanced_Frame_Relay_Configuration;

	sub new
	{
		my $proto = shift;
             	my $class = ref($proto) || $proto;
		my $self = {};

		print "IN Advanced_Frame_Relay_Configuration OBJECT <br>";

		bless ($self,$class);
		return $self;
	}


	sub AUTOLOAD 
	{
		my $self = shift;
		my $value = shift;

		print "Advanced_Frame_Relay_Configuration Autoload Value=$value <br>";
		return 1;
	}

	sub display
	{
		print "Advanced_Frame_Relay_Configuration : in display() <br>";
		return 0;
	}

